import gtk
import gtk.glade
import gobject

from Source import AptSource, DebSource

class DialogAptSourceAdd:
    def __init__(self, parent, datadir):
        self.gladexml = gtk.glade.XML(datadir+'/glade/dialogs.glade')
        
        self.dialog = self.gladexml.get_widget('dialog_aptadd')
        self.dialog.set_transient_for(parent)
        self.button_add = self.gladexml.get_widget('button_aptadd')
        
        self.entry_name = self.gladexml.get_widget('entry_aptadd_name')
        self.entry_name.connect('changed', self.check_entry)
        self.entry_pkg = self.gladexml.get_widget('entry_aptadd_pkg')
        self.entry_pkg.connect('changed', self.check_entry)
        self.entry_key = self.gladexml.get_widget('entry_aptadd_key')
        self.entry_bin = self.gladexml.get_widget('entry_aptadd_bin')
        self.entry_src = self.gladexml.get_widget('entry_aptadd_src')
        
    def run(self):
        res = self.dialog.run()
        self.dialog.hide()
        if res == gtk.RESPONSE_OK:
            name = self.entry_name.get_text()
            pkg = self.entry_pkg.get_text()
            key = self.entry_key.get_text()
            bin = self.entry_bin.get_text()
            src = self.entry_src.get_text()
            if key == "": key = None
            if bin == "": bin = None
            if src == "": src = None
            source = AptSource(name, pkg, key, bin, src)
            return source
    
    def check_entry(self, *args):
        if self.entry_name.get_text() == "" or self.entry_pkg.get_text() == "":
            self.button_add.set_sensitive(False)
        else:
            self.button_add.set_sensitive(True)
            
class DialogDebSourceAdd:
    def __init__(self, parent, datadir):
        self.gladexml = gtk.glade.XML(datadir+'/glade/dialogs.glade')
        
        self.dialog = self.gladexml.get_widget('dialog_debadd')
        self.dialog.set_transient_for(parent)
        self.button_add = self.gladexml.get_widget('button_debadd')
        
        self.entry_name = self.gladexml.get_widget('entry_debadd_name')
        self.entry_name.connect('changed', self.check_entry)
        self.entry_pkg = self.gladexml.get_widget('entry_debadd_pkg')
        self.entry_pkg.connect('changed', self.check_entry)
        self.entry_ver = self.gladexml.get_widget('entry_debadd_ver')
        self.entry_url = self.gladexml.get_widget('entry_debadd_url')
        self.entry_url.connect('changed', self.check_entry)
        
    def run(self):
        res = self.dialog.run()
        self.dialog.hide()
        if res == gtk.RESPONSE_OK:
            name = self.entry_name.get_text()
            pkg = self.entry_pkg.get_text()
            url = self.entry_url.get_text()
            ver = self.entry_ver.get_text()
            if ver == "": ver = None
            source = DebSource(name, pkg, ver, url)
            return source
    
    def check_entry(self, *args):
        if self.entry_name.get_text() == "" or self.entry_pkg.get_text() == "" or self.entry_url.get_text() == "":
            self.button_add.set_sensitive(False)
        else:
            self.button_add.set_sensitive(True)