#!/usr/bin/env python
# -*- coding: utf-8 -*-
# vowel - DBConnection.py

from pysqlite2 import dbapi2 as sqlite

class DBConnection:
    __instance = None
    class Singleton:
        def __init__(self):
            pass
            
        def connect(self, dbname):
            try:
                self._con = sqlite.connect(dbname)
                return True
            except sqlite.OperationalError, e:
                print e
                return False
        def cursor(self):
            self._cur = self._con.cursor()
            
        def execute(self, *statement):
            try:
                self._cur.execute(*statement)
            except sqlite.OperationalError, e:
                print e
                return False
##            statement = 'select * from %s where code=:code order by name' % table
##            self.cur.execute(statement, locals())

        def fetchall(self):
            data = self._cur.fetchall()
            return data
        
        def commit(self):
            self._con.commit()
                
    def __init__(self):
        if DBConnection.__instance is None:
            DBConnection.__instance = DBConnection.Singleton()
            
        self.__dict__['_EventHandler_instance'] = DBConnection.__instance
        
    def __getattr__(self, attr):
        return getattr(self.__instance, attr)
    
    def __setattr__(self, attr, value):
        return setattr(self.__instance, attr, value)