#!/usr/bin/env python
# -*- coding: utf-8 -*-
# vowel - Source.py

class Source:
    def __init__(self, name, package):
        self._name = name
        self._package = package  
    
    def get_name(self):
        """ Get a name attribute """
        return self._name
    
    def get_package(self):
        """ Get a package attribute """
        return self._package

class AptSource(Source):
    def __init__(self, name, package, key, bin_repo, src_repo):
        Source.__init__(self, name, package)
        self._key = key
        self._bin_repo = bin_repo
        self._src_repo = src_repo
    
    def get_key(self):
        """ Get a key attribute """
        return self._key
    
    def get_bin_repo(self):
        """ Get a bin_repo attribute """
        return self._bin_repo
    
    def get_src_repo(self):
        """ Get a src_repo attribute """
        return self._src_repo
    
class DebSource(Source):
    def __init__(self, name, package, version, url):
        Source.__init__(self, name, package)
        self._version = version
        self._url = url
        
    def get_version(self):
        """ Get a version attribute """
        return self._version
    
    def get_url(self):
        """ Get a URL attribute """
        return self._url